<!DOCTYPE html>
<html>
<head>
  <meta http-equiv="content-type" content="text/html;charset=utf-8">
  <title>alighnw_lib.py</title>
  <link rel="stylesheet" href="pycco.css">
</head>
<body>
<div id='container'>
  <div id="background"></div>
  <div class='section'>
    <div class='docs'><h1>alighnw_lib.py</h1></div>
  </div>
  <div class='clearall'>
  <div class='section' id='section-0'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-0'>#</a>
      </div>
      <p>Program which recreates the Needleman Wunsch alignment.
Currently we support the following 3 functions:</p>
<ol>
<li>
<p><strong>Get_matrix</strong> - Create the matrix of sequences</p>
</li>
<li>
<p><strong>Get_max_score</strong> - Return max score</p>
</li>
<li><strong>Get_alignment</strong> - Return alignment</li>
</ol>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span></span><span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-1'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-1'>#</a>
      </div>
      <h3><span id="get_matrix" href="get_matrix"> get_matrix </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">get_matrix</span><span class="p">(</span><span class="n">secuencia1</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">secuencia2</span><span class="p">:</span> <span class="nb">str</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-2'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-2'>#</a>
      </div>
      <p>Create the matrix of sequence 1 and  of sequence 2</p>
<p>Arguments:</p>
<p>secuencia2 {str} &ndash; sequence one</p>
<p>secuencia1 {str} &ndash; sequence two</p>
<p>Returns:</p>
<p>[np.ndarray] &ndash; matrix of alignment</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">filas</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">secuencia2</span><span class="p">)</span>
    <span class="n">columnas</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">secuencia1</span><span class="p">)</span>
    <span class="n">matrix</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">zeros</span><span class="p">([</span><span class="n">filas</span><span class="o">+</span><span class="mi">1</span><span class="p">,</span> <span class="n">columnas</span><span class="o">+</span><span class="mi">1</span><span class="p">],</span> <span class="nb">int</span><span class="p">)</span>
    <span class="n">penalty</span> <span class="o">=</span> <span class="o">-</span><span class="mi">1</span>
    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">filas</span><span class="o">+</span><span class="mi">1</span><span class="p">):</span>
        <span class="n">matrix</span><span class="p">[</span><span class="n">i</span><span class="p">,</span> <span class="mi">0</span><span class="p">]</span> <span class="o">=</span> <span class="n">penalty</span><span class="o">*</span><span class="n">i</span>
    <span class="k">for</span> <span class="n">j</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">columnas</span><span class="o">+</span><span class="mi">1</span><span class="p">):</span>
        <span class="n">matrix</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span> <span class="n">j</span><span class="p">]</span> <span class="o">=</span> <span class="n">penalty</span><span class="o">*</span><span class="n">j</span>
    <span class="k">for</span> <span class="n">j</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">columnas</span><span class="p">):</span>
        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">filas</span><span class="p">):</span>
            <span class="n">letra2</span> <span class="o">=</span> <span class="n">secuencia2</span><span class="p">[</span><span class="n">i</span><span class="p">]</span>
            <span class="n">letra1</span> <span class="o">=</span> <span class="n">secuencia1</span><span class="p">[</span><span class="n">j</span><span class="p">]</span>
            <span class="k">if</span> <span class="n">letra2</span> <span class="o">==</span> <span class="n">letra1</span><span class="p">:</span>
                <span class="n">concurrence</span> <span class="o">=</span> <span class="mi">1</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">concurrence</span> <span class="o">=</span> <span class="o">-</span><span class="mi">1</span>
            <span class="n">fat</span> <span class="o">=</span> <span class="nb">max</span><span class="p">(</span><span class="n">matrix</span><span class="p">[</span><span class="n">i</span><span class="p">,</span> <span class="n">j</span><span class="p">]</span><span class="o">+</span><span class="n">concurrence</span><span class="p">,</span>
                      <span class="n">matrix</span><span class="p">[</span><span class="n">i</span><span class="o">+</span><span class="mi">1</span><span class="p">,</span> <span class="n">j</span><span class="p">]</span><span class="o">+</span><span class="n">penalty</span><span class="p">,</span> <span class="n">matrix</span><span class="p">[</span><span class="n">i</span><span class="p">,</span> <span class="n">j</span><span class="o">+</span><span class="mi">1</span><span class="p">]</span><span class="o">+</span><span class="n">penalty</span><span class="p">)</span>
            <span class="n">matrix</span><span class="p">[</span><span class="n">i</span><span class="o">+</span><span class="mi">1</span><span class="p">,</span> <span class="n">j</span><span class="o">+</span><span class="mi">1</span><span class="p">]</span> <span class="o">=</span> <span class="n">fat</span>
    <span class="k">return</span> <span class="n">matrix</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-3'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-3'>#</a>
      </div>
      <h3><span id="get_max_score" href="get_max_score"> get_max_score </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-4'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-4'>#</a>
      </div>
      <p>Return max score</p>
<p>Arguments:</p>
<p>matrix {np.ndarray} &ndash; matrix of alignment</p>
<p>Returns:
  [int] &ndash; max score</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">get_max_score</span><span class="p">(</span><span class="n">matrix</span><span class="p">:</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-5'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-5'>#</a>
      </div>
      
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">score</span> <span class="o">=</span> <span class="n">matrix</span><span class="p">[</span><span class="n">matrix</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span> <span class="n">matrix</span><span class="o">.</span><span class="n">shape</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
    <span class="k">return</span> <span class="n">score</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-6'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-6'>#</a>
      </div>
      <h3><span id="get_alignment" href="get_alignment"> get_alignment </span></h3>
    </div>
    <div class='code'>
      <div class="highlight"><pre></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-7'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-7'>#</a>
      </div>
      <p>Return alignment</p>
<p>Arguments:</p>
<p>matrix {np.ndarray} &ndash; matrix of alignment</p>
<p>secuencia1 {str} &ndash; sequence one</p>
<p>secuencia2 {str} &ndash; sequence two</p>
<p>Returns:
  [list] &ndash; alignment</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">get_alignment</span><span class="p">(</span><span class="n">matrix</span><span class="p">:</span> <span class="n">np</span><span class="o">.</span><span class="n">ndarray</span><span class="p">,</span> <span class="n">secuencia1</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">secuencia2</span><span class="p">:</span> <span class="nb">str</span><span class="p">):</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-8'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-8'>#</a>
      </div>
      
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">result</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">i</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">secuencia2</span><span class="p">)</span>
    <span class="n">j</span> <span class="o">=</span> <span class="nb">len</span><span class="p">(</span><span class="n">secuencia1</span><span class="p">)</span>
    <span class="n">string1</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="n">string1_list</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">string2</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="n">string2_list</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">string3</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="n">string3_list</span> <span class="o">=</span> <span class="p">[]</span>

    <span class="n">penalty</span> <span class="o">=</span> <span class="o">-</span><span class="mi">1</span>
    <span class="k">while</span><span class="p">(</span><span class="n">i</span> <span class="o">&gt;</span> <span class="mi">0</span> <span class="ow">or</span> <span class="n">j</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">):</span>
        <span class="k">if</span> <span class="n">secuencia2</span><span class="p">[</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">==</span> <span class="n">secuencia1</span><span class="p">[</span><span class="n">j</span><span class="o">-</span><span class="mi">1</span><span class="p">]:</span>
            <span class="n">concurrence</span> <span class="o">=</span> <span class="mi">1</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">concurrence</span> <span class="o">=</span> <span class="o">-</span><span class="mi">1</span>
        <span class="k">if</span> <span class="n">i</span> <span class="o">&gt;</span> <span class="mi">0</span> <span class="ow">and</span> <span class="n">j</span> <span class="o">&gt;</span> <span class="mi">0</span> <span class="ow">and</span> <span class="n">matrix</span><span class="p">[</span><span class="n">i</span><span class="p">,</span> <span class="n">j</span><span class="p">]</span> <span class="o">==</span> <span class="n">matrix</span><span class="p">[</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span> <span class="n">j</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span><span class="o">+</span><span class="n">concurrence</span><span class="p">:</span>
            <span class="n">string1</span> <span class="o">=</span> <span class="n">string1</span><span class="o">+</span><span class="n">secuencia1</span><span class="p">[</span><span class="n">j</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
            <span class="n">string1_list</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">string1</span><span class="o">+</span><span class="n">secuencia1</span><span class="p">[</span><span class="n">j</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span><span class="o">.</span><span class="n">upper</span><span class="p">())</span>
            <span class="n">string2</span> <span class="o">=</span> <span class="n">string2</span><span class="o">+</span><span class="n">secuencia2</span><span class="p">[</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
            <span class="n">string2_list</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">string2</span><span class="o">+</span><span class="n">secuencia2</span><span class="p">[</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span><span class="o">.</span><span class="n">upper</span><span class="p">())</span>
            <span class="n">string3</span> <span class="o">=</span> <span class="n">string3</span><span class="o">+</span><span class="s2">&quot;|&quot;</span>
            <span class="n">string3_list</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">string3</span><span class="o">+</span><span class="s2">&quot;|&quot;</span><span class="p">)</span><span class="o">.</span><span class="n">upper</span><span class="p">())</span>
            <span class="n">i</span> <span class="o">=</span> <span class="n">i</span><span class="o">-</span><span class="mi">1</span>
            <span class="n">j</span> <span class="o">=</span> <span class="n">j</span><span class="o">-</span><span class="mi">1</span>
        <span class="k">elif</span> <span class="n">i</span> <span class="o">&gt;</span> <span class="mi">0</span> <span class="ow">and</span> <span class="n">matrix</span><span class="p">[</span><span class="n">i</span><span class="p">,</span> <span class="n">j</span><span class="p">]</span> <span class="o">==</span> <span class="n">matrix</span><span class="p">[</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span> <span class="n">j</span><span class="p">]</span><span class="o">+</span><span class="n">penalty</span><span class="p">:</span>
            <span class="n">string1</span> <span class="o">=</span> <span class="n">string1</span><span class="o">+</span><span class="s2">&quot;-&quot;</span>
            <span class="n">string1_list</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">string1</span><span class="o">+</span><span class="s2">&quot;-&quot;</span><span class="p">)</span><span class="o">.</span><span class="n">upper</span><span class="p">())</span>
            <span class="n">string2</span> <span class="o">=</span> <span class="n">string2</span><span class="o">+</span><span class="n">secuencia2</span><span class="p">[</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
            <span class="n">string2_list</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">string2</span><span class="o">+</span><span class="n">secuencia2</span><span class="p">[</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span><span class="o">.</span><span class="n">upper</span><span class="p">())</span>
            <span class="n">string3</span> <span class="o">=</span> <span class="n">string3</span><span class="o">+</span><span class="s2">&quot; &quot;</span>
            <span class="n">string3_list</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">string3</span><span class="o">+</span><span class="s2">&quot; &quot;</span><span class="p">)</span><span class="o">.</span><span class="n">upper</span><span class="p">())</span>
            <span class="n">i</span> <span class="o">=</span> <span class="n">i</span><span class="o">-</span><span class="mi">1</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">string1</span> <span class="o">=</span> <span class="n">string1</span><span class="o">+</span><span class="n">secuencia1</span><span class="p">[</span><span class="n">j</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
            <span class="n">string1_list</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">string1</span><span class="o">+</span><span class="n">secuencia1</span><span class="p">[</span><span class="n">j</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span><span class="o">.</span><span class="n">upper</span><span class="p">())</span>
            <span class="n">string2</span> <span class="o">=</span> <span class="n">string2</span><span class="o">+</span><span class="s2">&quot;-&quot;</span>
            <span class="n">string2_list</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">string2</span><span class="o">+</span><span class="s2">&quot;-&quot;</span><span class="p">)</span><span class="o">.</span><span class="n">upper</span><span class="p">())</span>
            <span class="n">string3</span> <span class="o">=</span> <span class="n">string3</span><span class="o">+</span><span class="s2">&quot; &quot;</span>
            <span class="n">string3_list</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">string3</span><span class="o">+</span><span class="s2">&quot; &quot;</span><span class="p">)</span><span class="o">.</span><span class="n">upper</span><span class="p">())</span>
            <span class="n">j</span> <span class="o">=</span> <span class="n">j</span><span class="o">-</span><span class="mi">1</span>

    <span class="n">result</span> <span class="o">=</span> <span class="p">[</span><span class="n">string1</span><span class="p">[::</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">string3</span><span class="p">[::</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span> <span class="n">string2</span><span class="p">[::</span><span class="o">-</span><span class="mi">1</span><span class="p">]]</span>
    <span class="n">result</span> <span class="o">=</span> <span class="p">[</span><span class="n">x</span><span class="o">.</span><span class="n">upper</span><span class="p">()</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="n">result</span><span class="p">]</span>
    <span class="k">return</span> <span class="n">result</span>

</pre></div>
    </div>
  </div>
  <div class='clearall'></div>
</div>
</body>
